#!/bin/env python
# -*- coding: utf-8 -*-

# ------------------------------------------------------------
# test_vmmanger
#
# test the open security vmmanager
#   
# Autor: Mihai Bartha, <mihai.bartha@ait.ac.at>       
#
# Copyright 2013-2014 X-Net and AIT Austrian Institute of Technology
# 
# 
#     X-Net Services GmbH
#     Elisabethstrasse 1
#     4020 Linz
#     AUSTRIA
#     https://www.x-net.at
# 
#     AIT Austrian Institute of Technology
#     Donau City Strasse 1
#     1220 Wien
#     AUSTRIA
#     http://www.ait.ac.at
# 
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ------------------------------------------------------------


# ------------------------------------------------------------
# imports

import unittest

import os
import re
import os.path
import sys
import cygwin
import vmmanager
import _winreg
import time
gvm_mgr = None

class TestVMManager(unittest.TestCase):
    
    def setUp(self):
        pass
    
    @classmethod
    def setUpClass(self):
        global gvm_mgr
        gvm_mgr = vmmanager.VMManager.getInstance()
        pass
    
    #@classmethod
    #def tearOffClass(self):
    #    gvm_mgr.stop()
    #    gvm_mgr.cleanup()
    
    @unittest.skip("skipping")
    def testGetTemplateUUID(self):
        template = vmmanager.VMManager.getVDiskUUID(gvm_mgr.templateImage)
        self.assertIsNotNone(template,  "returned no UUID for template")
    
    @unittest.skip("skipping")    
    def testUpdateTemplate(self):
        gvm_mgr.updateTemplate()
        pass
    
    def setKey(self, key, name, value):
        _, reg_type = _winreg.QueryValueEx(key, name)
        _winreg.SetValueEx(key, name, 0, reg_type, value)
    
    @unittest.skip("skipping")    
    def testGetProxySettings(self):
        #sudo echo "http_proxy=http://80.122.169.38:8080/" >> /etc/environment
        aReg = _winreg.ConnectRegistry(None,_winreg.HKEY_CURRENT_USER)
        aKey = _winreg.OpenKey(aReg, r"Software\Microsoft\Windows\CurrentVersion\Internet Settings")
        subCount, valueCount, lastModified = _winreg.QueryInfoKey(aKey)
        proxy = dict()
        for i in range(valueCount):                                           
            try:
                n,v,t = _winreg.EnumValue(aKey,i)
                proxy[n] = v
            except EnvironmentError:                                               
                break
        _winreg.CloseKey(aKey)
        print proxy
        if 'ProxyEnable' in proxy.keys() and proxy['ProxyEnable'] == 1:
            print proxy['ProxyServer']
            return proxy['ProxyServer']
        else: 
            return ""
    
    @unittest.skip("skipping")      
    def testMatchProxy(self):
        #http=212.17.86.109:8080;https=212.17.86.109:8080;ftp=212.17.86.109:8080
        #212.17.86.109:8080
        text = 'http=212.17.86.109:8080;https=212.17.86.109:8080;ftp=212.17.86.109:8080'
        print re.search(r"(?<=http=)(?P<HttpProxy>.*?)(?=;)", text).groupdict()
        print re.search(r"(?<=http=)(.*?)(?=;)", text)
        
    
    
    @unittest.skip("skipping")
    def testImportTemplate(self):
        gvm_mgr.cleanup()
        if 'SecurityDVM' in gvm_mgr.listVMS():
            gvm_mgr.removeVM('SecurityDVM')
        
        uuid = gvm_mgr.getVDiskUUID(gvm_mgr.templateImage)
        if uuid:
            gvm_mgr.removeImage(uuid)
        
        gvm_mgr.removeVMFolder('SecurityDVM')
        gvm_mgr.importTemplate('C:\Windows\System32\config\systemprofile\VirtualBox VMs\OsecVM.ova')
        gvm_mgr.updateTemplate()
   
    @unittest.skip("skipping")   
    def testHostOnlyDHCP(self):
        #list hostonlyifs
        #Cygwin.vboxExecute("list hostonlyifs")
        
        hostonlyifs = gvm_mgr.getHostOnlyIFs()
        print hostonlyifs
        
        dhcpservers = gvm_mgr.getDHCPServers()
        print dhcpservers
        
    def testBrowsingRequest(self):
        gvm_mgr.start()
        gvm_mgr.handleBrowsingRequest()
        time.sleep(3000)
        pass
        
if __name__ == '__main__':
    TestVMManager.setUpClass()
    
    suite = unittest.TestLoader().loadTestsFromTestCase(TestVMManager)
    unittest.TextTestRunner().run(suite)
    
    #VBoxManage list hostonlyifs
    #VBoxManage list dhcpservers
    #VBoxManage dhcpserver remove --netname "HostInterfaceNetworking-VirtualBox Host-Only Ethernet Adapter"
    #VBoxManage dhcpserver add --ifname "VirtualBox Host-Only Ethernet Adapter" --ip 192.168.56.100 --netmask 255.255.255.0 --lowerip 192.168.56.101 --upperip 192.168.56.254 --enable
    #VBoxManage dhcpserver modify --ifname "VirtualBox Host-Only Ethernet Adapter" --enable
    #VBoxManage hostonlyif ipconfig "VirtualBox Host-Only Ethernet Adapter" --dhcp
    #VBoxManage hostonlyif ipconfig "VirtualBox Host-Only Ethernet Adapter" --ip 192.168.56.1 --netmask 255.255.255.0    
#    logger = setupLogger('Cygwin')
#    c = Cygwin()
#    unittest.main()
    #man = VMManager.getInstance()
    #man.listVM()
    #print man.getConnectedRSDs()
    #print man.getNetworkDrives()
    #man.genNetworkDrive()
    #drive_bitmask = ctypes.cdll.kernel32.GetLogicalDrives()
    #print list(itertools.compress(string.ascii_uppercase,  map(lambda x:ord(x) - ord('0'), bin(drive_bitmask)[:1:-1])))
    #print list(map(chr, range(68, 91))) 
    #print Cygwin.getRegEntry('SYSTEM\CurrentControlSet\Enum\USB', 'VID_1058&PID_0704')[0]
    #devices = VMManager.getConnectedRSDS()
    #print devices
    
    #drives = VMManager.getLogicalDrives()
    #print drives
    #print VMManager.getDriveType("E")
    #print VMManager.getVolumeInfo("E")
    #print VMManager.getNetworkPath("E")
    
    #vmm.backupFile()
    #for device in devices.values():
    #    #print device
    #    if VMManager.isMassStorageDevice(device):
    #        print device
        
    
    
    #time.sleep(-1)
    #man.listVM()
    #man.listVM()
    #man.listVM()
    #man.listVM()
    #man.genCertificateISO('SecurityDVM0')
    #man.guestExecute('SecurityDVM0', '/bin/ls -la')
    #logger = setupLogger('VMManager')
    #c = Cygwin()
    
    #man.sshExecute('/bin/ls -la', 'SecurityDVM0')
    #man.sshExecuteX11('/usr/bin/iceweasel', 'SecurityDVM0')
    #man.removeVM('SecurityDVM0')
    #man.netUse('192.168.56.134', 'USB\\')
    #ip = '192.168.56.139'
    
    #man.cygwin_path = 'c:\\cygwin64\\bin\\'
    #man.handleDeviceChange()
    #print man.listSDVM()
    #man.configureHostNetworking()
    #new_vm = man.generateSDVMName()
    #man.createVM(new_vm)
    
    #print Cygwin.cmd()
    #man.isAvailable('c:')
    #ip = man.getHostOnlyIP('SecurityDVM0')
    #man.mapNetworkDrive('h:', '\\\\' + ip + '\Download', None, None)
    
    #man.genCertificateISO(new_vm)
    #man.attachCertificateISO(new_vm)
    
    #man.attachCertificateISO(vm_name)
    #man.guestExecute(vm_name, "ls")
    #man.sshGuestX11Execute('SecurityDVM1', '/usr/bin/iceweasel')
    #time.sleep(60)
    #print man.cygwinPath("C:\Users\BarthaM\VirtualBox VMs\SecurityDVM\.ssh\*")
    #man.genCertificateISO('SecurityDVM')
    #man.attachCertificateISO('SecurityDVM')
    #man.isStorageAttached('SecurityDVM')
    #man.guestExecute('SecurityDVM', 'sudo apt-get -y update')
    #man.guestExecute('SecurityDVM', 'sudo apt-get -y upgrade' )
    
    #man.stopVM('SecurityDVM')
    #man.detachStorage('SecurityDVM')
    #man.changeStorageType('C:\Users\BarthaM\VirtualBox VMs\SecurityDVM\SecurityDVM.vmdk','immutable')
    #man.storageAttach('SecurityDVM')
    
    
    #cmd = "c:\\cygwin64\\bin\\bash.exe --login -c \"/bin/ls\""
    #man.execute(cmd)
